/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#include "MixCastRoomComponent.h"

#include "MixCastSdkActor.h"
#include "Tracking/TrackingUtil.hpp"

void UMixCastRoomComponent::BeginPlay()
{
	Super::BeginPlay();

	beforeFrameDelegate = IMixCast::Get().OnBeforeFrame().AddUObject(this, &UMixCastRoomComponent::HandleMixCastAboutToRender);
}
void UMixCastRoomComponent::EndPlay(const EEndPlayReason::Type endPlayReason)
{
	IMixCast::Get().OnBeforeFrame().Remove(beforeFrameDelegate);
	
	Super::EndPlay(endPlayReason);
}

void UMixCastRoomComponent::HandleMixCastAboutToRender()
{
	if(TrackingUtil::GetCurrentTrackingType() != mixcast::data::TrackingSource::UNKNOWN)
		return;

	AMixCastSdkActor::SetWorldTransform(GetComponentTransform());
}

