#pragma once

#if PLATFORM_WINDOWS
#include "Windows/AllowWindowsPlatformTypes.h"
#endif
#include <Windows.h>
#include <stdio.h>
#include <conio.h>
#if PLATFORM_WINDOWS
#include "Windows/HideWindowsPlatformTypes.h"
#endif

#include "CoreMinimal.h"
#include "Engine/Texture2D.h"
#include "RHICommandList.h"

#include "MixCastDefines.h"
#include "../../../MixCastLog.h"

typedef enum DXGI_FORMAT;

class OwnedUnrealSharedTexture
{
protected:
	static void* GetNativeTexture(const UTexture& tex);
	static DXGI_FORMAT EnsureShareableFormat(DXGI_FORMAT format);

	UTexture* srcTex;

	HANDLE sharedHandle = NULL;

	virtual void Write_RenderThread(FRHICommandListImmediate& RHICmdList) = 0;

public:
	static OwnedUnrealSharedTexture* Create(UTexture* srcTex);

	virtual ~OwnedUnrealSharedTexture() {}

	void EnqueueWrite(UTexture* newSrcTex)
	{
		srcTex = newSrcTex;
		EnqueueWrite();
	}
	void EnqueueWrite()
	{
		ENQUEUE_RENDER_COMMAND(void)(
			[&](FRHICommandListImmediate& RHICmdList)
		{
			Write_RenderThread(RHICmdList);
		});
	}

	HANDLE GetHandle() { return sharedHandle; }
};