#pragma once

#include "WatchedUnrealSharedTexture.h"

typedef struct ID3D11Device1;
typedef struct IDXGIKeyedMutex;
typedef struct ID3D11Texture2D;

class WatchedUnrealSharedTexture_D3D11 : public WatchedUnrealSharedTexture
{
private:
	ID3D11Device1* device = NULL;

	bool ntHandles = false;

	HANDLE localHandle = 0;
	IDXGIKeyedMutex* mutex = NULL;

	ID3D11Texture2D* sharedTex = NULL;
	unsigned long width = 0, height = 0;

#if MIXCAST_D3D12
	FTexture2DRHIRef sharedTexRhi;
#endif

	void Initialize(HANDLE texHandle);

public:
	WatchedUnrealSharedTexture_D3D11(HANDLE texHandle)
	{
		this->ntHandles = false;
		Initialize(texHandle);
	}
	WatchedUnrealSharedTexture_D3D11(HANDLE srcProcHandle, HANDLE remoteTexHandle)
	{
		this->ntHandles = true;
		if (DuplicateHandle(srcProcHandle, remoteTexHandle, GetCurrentProcess(), &localHandle, NULL, true, DUPLICATE_SAME_ACCESS))
			Initialize(localHandle);
	}

	virtual ~WatchedUnrealSharedTexture_D3D11() override;

	virtual void Read_RenderThread(FRHICommandListImmediate& RHICmdList) override;
};