/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#pragma once

#include "CoreMinimal.h"
#include "Kismet/BlueprintFunctionLibrary.h"

#include "MixCastActorVisibility.h"

#include "MixCastBPFunctionLibrary.generated.h"

UCLASS()
class MIXCAST_API UMixCastBPFunctionLibrary : public UBlueprintFunctionLibrary
{
	GENERATED_BODY()

	UFUNCTION(BlueprintPure, Category = "MixCast")
	static FTransform GetMixCastOrigin();

	UFUNCTION(BlueprintCallable, Category = "MixCast")
	static void SendExperienceEvent(FString eventStr);

	UFUNCTION(BlueprintCallable, Category = "MixCast")
	static void SetActorVisibilityForMixCast(AActor* actor, 
		bool showForRegularCameras = true,
		bool showForMixCastCameras = true,
		TEnumAsByte<EMixCastCameraMode::Type> mixCastCameraMode = EMixCastCameraMode::Always,
		TEnumAsByte<ERenderTypeCondition::Type> renderTypeCondition = ERenderTypeCondition::NotUsed,
		TEnumAsByte<EPerspectiveCondition::Type> perspectiveCondition = EPerspectiveCondition::NotUsed);
};
