/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

using System.IO;
using UnrealBuildTool;

namespace UnrealBuildTool.Rules
{
	public class MixCast_Shaders : ModuleRules
	{
        public MixCast_Shaders(ReadOnlyTargetRules Target) : base(Target)
		{
            PCHUsage = ModuleRules.PCHUsageMode.UseExplicitOrSharedPCHs;

#if UE_4_19_OR_LATER
			var definitions = PublicDefinitions;
#else
			var definitions = Definitions;
#endif			

            PublicIncludePaths.AddRange(new string[]
                {
                    Path.Combine(ModuleDirectory,"Public"),

                    Path.Combine(ModuleDirectory, "..", "MixCast", "Public"),
                });

            PrivateIncludePaths.AddRange(new string[]
                {
                    Path.Combine(ModuleDirectory,"Private"),
                });

            PublicDependencyModuleNames.AddRange(new string[]
                {
                    "Core",
                    "CoreUObject",
                    "Engine",
                    "RHI",
                    "RenderCore",
                    "Renderer",
#if !UE_4_22_OR_LATER
                    "ShaderCore",
#endif
                });
            PrivateDependencyModuleNames.AddRange(new string[]
                {
                    "Core",
                    "CoreUObject",
                    "Engine",
                    "RHI",
                    "RenderCore",
                    "Renderer",
                    "Projects",
#if !UE_4_22_OR_LATER
                    "ShaderCore",
#endif
                });
        }
    }
}
